#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <dos.h>

// -- Defines -----------------------
#define BUILD "0008 ALPHA"

#define MAX_MAP_XSIZE 100
#define MAX_MAP_YSIZE 100

#define MAX_VIEWS 4

#define MAX_PL 10
#define MAX_PL_LENGTH 30

#define MAP_FILE_NAME "MAP01.PMF"
// ----------------------------------

// Map fields
struct s_mapf {
				unsigned char m; // Map field properties
				unsigned char c; // Char
				unsigned char f,b; // Foreground, background color
			  } mapf[255];

// Game map
int n_map_xsize=MAX_MAP_XSIZE;
int n_map_ysize=MAX_MAP_YSIZE;
struct s_map {
			   char name[127]; // Map name
			   unsigned char m[MAX_MAP_XSIZE][MAX_MAP_YSIZE]; // Map fields properties
			   //unsigned char p[MAX_MAP_XSIZE][MAX_MAP_YSIZE];
			 } map;

// Player views
int n_views=0; // Number of active player views
struct s_views {
				 int xp,yp; // X and Y position on screen
				 int xm,ym; // X and Y position on map
				 int xs,ys; // X and Y size to display
				 unsigned char mv; // Moving (0..249 - pl num., 250 - don't move)
				 s_map tm1;  // Temporary map (for screen redraw)
			   } views[MAX_VIEWS];

// Player info
unsigned char n_pl=0; // Number of active players
struct s_pl {
			  char name[127]; // Player name
			  unsigned char pcolor,phchar; // Player color, Player head character
			  unsigned char d; // Actual player direction (0=nothing, 1=up, 2=down, 3=left, 4=right)
			  unsigned char alen; //,blen; // Actual length, Absolute length(length to be)
			  float blen; // Absolute length(length to be)
			  int x[MAX_PL_LENGTH],y[MAX_PL_LENGTH]; // Player fields
			  unsigned char xsl,ysl; // X and Y status location (on screen)
			} pl[MAX_PL];

unsigned char end_p=0;
unsigned long timer1=0; // Game timer

// -------------------------------------------------------------------------

void tcolor(int fc, int bc)
{
  textcolor(fc);
  textbackground(bc);
}

// -------------------------------------------------------------------------
void redraw_basic_screen()
// Draw text and gfx which is not changed during game on the screen
{
  // Display some copyright information
  tcolor(7,0);
  clrscr();
  gotoxy (1,48);
  tcolor (15,0); cprintf("(c)2001 by JC & JK & JM.\r\n");
  tcolor ( 7,0); cprintf("Build \"%s\". Not for public use ;-).\r\n", BUILD);
				 cprintf("For more informations visit http://www.mobilnews.cz/pizdjozki/");
}

int xy_pl_exist(int x1, int y1, int wret)
// Check if there is a player on x1,y1
// 0 - 250 ... player number
//     254 ... last field of player (not showed)
//     255 ... there is no player

// Wret
// 0 ... player num
// 1 ... field num
{
  int i1,i2;

  for (i1=0; i1<n_pl; i1++) // Players 1...n
  {
	for (i2=0; i2<=pl[i1].alen; i2++) // 0...player length
	{
	  if ( (pl[i1].x[i2]==x1) && (pl[i1].y[i2]==y1) )
	  {
		switch (wret)
		{
		  case 0 : if (i2==pl[i1].alen) { return 254; }
								   else { return i1; }
				   break;
		  case 1 : return i2;
				   break;
		}
	  }
	}
  }

  return 255;
}

unsigned char mk_random_bkgchar()
{
  if (random(100)<60) { return (32+random(220)); }
				 else { return (32); }
}

void show_map(int m_num)
// Redraw map on the screen
{
  int ix,iy,i1,i2,i3;

  // Show map
  for (iy=views[m_num].ym; iy<(views[m_num].ym+views[m_num].ys); iy++)
  for (ix=views[m_num].xm; ix<(views[m_num].xm+views[m_num].xs); ix++)
  {
	// For faster redrawing remarked and moved
	// gotoxy ( (views[m_num].xp+ix-views[m_num].xm),(views[m_num].yp+iy-views[m_num].ym) );

	if ( (ix<0) || (iy<0) || !(ix<n_map_xsize) || !(iy<n_map_ysize) )
	//   && (views[m_num].tm1.m[(ix-views[m_num].xm)][(iy-views[m_num].ym)]!=254) )
	{
	  if (views[m_num].tm1.m[(ix-views[m_num].xm)][(iy-views[m_num].ym)]!=254)
	  {
		gotoxy ( (views[m_num].xp+ix-views[m_num].xm),(views[m_num].yp+iy-views[m_num].ym) );
		tcolor ( 8, 0); cprintf("%c",mk_random_bkgchar()); // Out of map range
		// (32+random(200)) (97+random(25)) cprintf(","); // Out of map range
		views[m_num].tm1.m[(ix-views[m_num].xm)][(iy-views[m_num].ym)]=254;
	  }
	}
	else
	{
	  i3=xy_pl_exist(ix,iy,0);
	  // This is for less redrawing - draw only changed things on the screen
	  if ( (views[m_num].tm1.m[(ix-views[m_num].xm)][(iy-views[m_num].ym)]) != (map.m[ix][iy])
		&& (i3>250) )
	  {
		gotoxy ( (views[m_num].xp+ix-views[m_num].xm),(views[m_num].yp+iy-views[m_num].ym) );

		// Map properties
		// 0 ... free field
		// 1 ... wall
		// 2 ... free field (not yet digged)
		// 3 ... food

		tcolor(mapf[ map.m[ix][iy] ].f, mapf[ map.m[ix][iy] ].b);
		if (mapf[ map.m[ix][iy] ].c!='@')
		{
		  cprintf("%c", mapf[ map.m[ix][iy] ].c);
		}
		else
		{
		  cprintf("%c",mk_random_bkgchar());
		}
		/*
		switch (map.m[ix][iy])
		{
		   case 0 : tcolor( 1, 1); cprintf(" "); break;
		   case 1 : tcolor(14,14); cprintf(""); break;
		   case 2 : tcolor( 9, 1); cprintf(""); break; // 4,1
		   case 3 : tcolor(10, 1); cprintf("O"); break;
		  default : tcolor( 7, 0); cprintf("X"); break;
		}
		*/
		// Write new map properties to the temporary map screen
		views[m_num].tm1.m[(ix-views[m_num].xm)][(iy-views[m_num].ym)]=map.m[ix][iy];
	  }

	  if (i3!=255)
	  {
		views[m_num].tm1.m[(ix-views[m_num].xm)][(iy-views[m_num].ym)]=255;
	  }
	}
  }

  // Show players
  for (i1=0; i1<n_pl; i1++) // Players 1...n
  {
	for (i2=0; i2<pl[i1].alen; i2++) // 0...player length
	{
	  ix=pl[i1].x[i2]-views[m_num].xm;
	  iy=pl[i1].y[i2]-views[m_num].ym;

	  // If player is in view, show it
	  if ( (ix>=0) && (iy>=0) && (ix<views[m_num].xs) && (iy<views[m_num].ys) )
	  {
		ix+=views[m_num].xp;
		iy+=views[m_num].yp;
		gotoxy (ix,iy);
		tcolor(pl[i1].pcolor, 1);
		switch (i2)
		{
		   case 0 : cprintf("%c",pl[i1].phchar); break;
		  default : cprintf(""); break;
		}
	  }
	  else // If player is not in view, show arrow
	  {
		// To be completed ;-)
	  }
	}
  }

  gotoxy (1,1);
}

void show_pl_stat(int pln)
// Show one line players statistics
{
  gotoxy (pl[pln].xsl,pl[pln].ysl);
  tcolor (pl[pln].pcolor,0); cprintf("");
  //tcolor (15,pl[pln].pcolor); cprintf ("  [ %s ] (%i,%i) %i %0.2f  ", pl[pln].name, pl[pln].x[0], pl[pln].y[0], pl[pln].alen, pl[pln].blen);
  tcolor (15,pl[pln].pcolor); cprintf ("  [ %s ] %i %0.2f  ", pl[pln].name, pl[pln].alen, pl[pln].blen);
  tcolor (pl[pln].pcolor,0); cprintf("۲   ");
}

void change_numofpl(int numofpl)
// This function will change number of active players in game
{
  int i1,i2,i3;

  switch (numofpl)
  {
	// 1 player
	case 1 : n_views=1;

			 views[0].xp=2;   views[0].yp=3;
			 views[0].xm=0;   views[0].ym=0;
			 views[0].xs=76;  views[0].ys=43;
			 //views[0].xs=77;  views[0].ys=20;
			 views[0].mv=0;

			 n_pl=1;
			 pl[0].xsl=2; pl[0].ysl=2;
			 break;

	// 2 players
	case 2 : n_views=2;

			 views[0].xp=2;   views[0].yp=3;
			 views[0].xm=0;   views[0].ym=0;
			 views[0].xs=36;  views[0].ys=43;
			 views[0].mv=0;

			 views[1].xp=42;  views[1].yp=3;
			 views[1].xm=0;   views[1].ym=0;
			 views[1].xs=36;  views[1].ys=43;
			 views[1].mv=1;

			 n_pl=2;
			 pl[0].xsl=2; pl[0].ysl=2;
			 pl[1].xsl=42; pl[1].ysl=2;
			 break;
	// 3 players
	case 3 : n_views=3;

			 views[0].xp=2;   views[0].yp=3;
			 views[0].xm=0;   views[0].ym=0;
			 views[0].xs=40;  views[0].ys=20;
			 views[0].mv=0;

			 views[1].xp=2;   views[1].yp=26;
			 views[1].xm=0;   views[1].ym=0;
			 views[1].xs=40;  views[1].ys=20;
			 views[1].mv=1;

			 views[2].xp=45;  views[2].yp=3;
			 views[2].xm=0;   views[2].ym=0;
			 views[2].xs=35;  views[2].ys=43;
			 views[2].mv=2;

			 n_pl=3;
			 pl[0].xsl=2;  pl[0].ysl=2;
			 pl[1].xsl=2;  pl[1].ysl=25;
			 pl[2].xsl=45; pl[2].ysl=2;
			 break;
  }

  for (i3=0; i3<n_pl; i3++)
  {
	for (i2=0; i2<MAX_MAP_YSIZE; i2++)
	for (i1=0; i1<MAX_MAP_XSIZE; i1++)
	{
	  views[i3].tm1.m[i1][i2]=255;
	}
  }

  redraw_basic_screen();
}

/*
void init_map()
// Initialise testing map
// This function will be replaced by function load_map() in future
{
  int ix,iy;

  // Map name
  strcpy(map.name,"Map1");

  // Initialise map fields
  for (iy=0; iy<n_map_ysize; iy++)
  for (ix=0; ix<n_map_xsize; ix++)
  {
	map.m[ix][iy]=0; // Clear all map fields

	// Create map borders
	if ( (ix==0) || (iy==0) || (ix==(n_map_xsize-1)) || (iy==(n_map_ysize-1)) )
	  {  map.m[ix][iy]=1;  }
  }

  // Digging fields
  for (iy=1; iy<((n_map_ysize / 2)+1); iy++)
  for (ix=(n_map_xsize-(n_map_xsize / 2)); ix<(n_map_xsize-1); ix++)
  {
	map.m[ix][iy]=2;
  }

  // Eating fields
  for (iy=((n_map_ysize / 2)+2); iy<(n_map_ysize-1); iy++)
  for (ix=((n_map_xsize / 2)+2); ix<(n_map_xsize-1); ix++)
  {
	if (random(100)<5)
	  {  map.m[ix][iy]=3;  }
  }

  // Cross in center
  for (ix=(n_map_xsize / 5); ix<((n_map_xsize / 5)*2); ix++)
  {
	map.m[ix][(n_map_ysize / 2)]=1;
	map.m[(ix+((n_map_xsize / 5)*2))][(n_map_ysize / 2)]=1;
  }

  for (iy=(n_map_ysize / 5); iy<((n_map_ysize / 5)*2); iy++)
  {
	map.m[(n_map_xsize / 2)][iy]=1;
	map.m[(n_map_xsize / 2)][(iy+((n_map_ysize / 5)*2))]=1;
  }
}
*/

void load_map(char map_file[])
{
  int i1,ix,iy;
  unsigned char chx;
  FILE *in;

  printf("\n");

  printf("Map file name: %s\n", map_file);

  if ((in = fopen(map_file, "rt")) == NULL)
  {
	 printf("Cannot open %s for reading.\n", map_file);
  }
  else
  {
	// Header
	printf("Map ID: ");
	for (i1=0; i1<5; i1++)
	{
	  chx=fgetc(in);
	  printf("%c", chx);
	}
	printf("\n");

	// Map size
	n_map_xsize=fgetc(in); // X_SIZE
	n_map_ysize=fgetc(in); // Y_SIZE

	printf("x_size / max_x_size: %i / %i\n", n_map_xsize, MAX_MAP_XSIZE);
	printf("y_size / max_y_size: %i / %i\n", n_map_ysize, MAX_MAP_YSIZE);

	for (i1=0; i1<255; i1++)
	{
	  mapf[i1].m=fgetc(in);
	  mapf[i1].c=fgetc(in);
	  mapf[i1].f=fgetc(in);
	  mapf[i1].b=fgetc(in);
	}

	if ( (n_map_xsize<=MAX_MAP_XSIZE) && (n_map_ysize<=MAX_MAP_YSIZE) )
	{
	  for (iy=0; iy<n_map_ysize; iy++)
	  for (ix=0; ix<n_map_xsize; ix++)
	  {
		map.m[ix][iy]=fgetc(in);
	  }

	  printf("OK, map successfully loaded.\n");
	}
	else
	{
	  printf("Map size is out of range.\n");
	}

	fclose(in);
  }

  printf("\n\nPress any key...");
  getch();
}

/*
void init_mapf()
{
  // m=0 ... normal playing field
  // m=1 ... wall
  // m=2 ... tuneler playing filed
  // m=3 ... eat

  mapf[0].m= 0; mapf[0].f= 1; mapf[0].b= 1; mapf[0].c=' ';
  mapf[1].m= 1; mapf[1].f=14; mapf[1].b=14; mapf[1].c='';
  mapf[2].m= 2; mapf[2].f= 9; mapf[2].b= 1; mapf[2].c='';
  mapf[3].m= 3; mapf[3].f=10; mapf[3].b= 1; mapf[3].c='O';
}
*/

void init_pl()
// Initialise testing players
{
  n_pl=2;

  // Player1
  strcpy(pl[0].name,"Player1");
  pl[0].pcolor=11;
  pl[0].phchar='';
  pl[0].d=0;
  pl[0].alen=1; pl[0].blen=5.0;
  pl[0].x[0]=5; pl[0].y[0]=5;
  //pl[0].xsl=1; pl[0].ysl=2;

  // Player2
  strcpy(pl[1].name,"Player2");
  pl[1].pcolor=10;
  pl[1].phchar='';
  pl[1].d=0;
  pl[1].alen=1; pl[1].blen=5.0;
  pl[1].x[0]=n_map_xsize-7; pl[1].y[0]=n_map_ysize-7;
  //pl[1].xsl=40; pl[1].ysl=2;

  // Player3
  strcpy(pl[2].name,"Player3");
  pl[2].pcolor=12;
  pl[2].phchar='';
  pl[2].d=0;
  pl[2].alen=1; pl[2].blen=5.0;
  pl[2].x[0]=n_map_xsize-7; pl[2].y[0]=5;
  //pl[1].xsl=40; pl[1].ysl=2;
}

void init_views()
// Initialise views
// This function is now handled by function change_numofpl()
{
  // Init some testing map views
  /*
  n_views=2;
  views[0].xp=1;   views[0].yp=3;
  views[0].xm=0;   views[0].ym=0;
  views[0].xs=38;  views[0].ys=10;
  views[0].mv=0;

  views[1].xp=40;  views[1].yp=3;
  views[1].xm=0;   views[1].ym=0;
  views[1].xs=38;  views[1].ys=10;
  views[1].mv=1;
  */
  change_numofpl(1);
}

// -------------------------------------------------------------------------

void get_keyb()
// This function handle everything about keyboard
{
  char ch;

  if (kbhit())
  {
	ch=getch();
	switch (ch)
	{
	  case 27 : end_p=1; break; // ESC

	  // Player 1 changes
	  case 'x' : pl[0].d=0; break; // Pause player pl[0]
	  case 'c' : pl[0].blen++; break; // Add length to pl[0]
	  case 'z' : pl[0].blen--; break; // Remove length from pl[0]

	  // Player 2 controls
	  case 'w' : if (pl[1].d!=2) pl[1].d=1; break; // Up arrow
	  case 's' : if (pl[1].d!=1) pl[1].d=2; break; // Down arrow
	  case 'a' : if (pl[1].d!=4) pl[1].d=3; break; // Left arrow
	  case 'd' : if (pl[1].d!=3) pl[1].d=4; break; // Right arrow

	  // Player 3 controls
	  case 'i' : if (pl[2].d!=2) pl[2].d=1; break; // Up arrow
	  case 'k' : if (pl[2].d!=1) pl[2].d=2; break; // Down arrow
	  case 'j' : if (pl[2].d!=4) pl[2].d=3; break; // Left arrow
	  case 'l' : if (pl[2].d!=3) pl[2].d=4; break; // Right arrow

	   case 0 : ch=getch();
				switch (ch)
				{
				  case 72 : if (pl[0].d!=2) pl[0].d=1; break; // Up arrow
				  case 80 : if (pl[0].d!=1) pl[0].d=2; break; // Down arrow
				  case 75 : if (pl[0].d!=4) pl[0].d=3; break; // Left arrow
				  case 77 : if (pl[0].d!=3) pl[0].d=4; break; // Right arrow

				  case 82 : change_numofpl(2); break; // INS
				  case 83 : change_numofpl(1); break; // DEL
				  case 71 : change_numofpl(3); break; // HOME
				}
				ch=0;
				break;
	}
  }
}

void redraw_screen()
{
  int i1;

  for (i1=0; i1<n_views; i1++)
  {
	show_map(i1);
  }

  for (i1=0; i1<n_pl; i1++)
  {
	show_pl_stat(i1);
  }
}

void do_game()
{
  int i1,i2,i3,c_move,new_x,new_y;

  for (i1=0; i1<n_pl; i1++) // Players 1...n
  {
	new_x=pl[i1].x[0];
	new_y=pl[i1].y[0];

	c_move=1;
	switch (pl[i1].d)
	{
	   // Up
	   case 1 : if ( !(mapf[ map.m[ pl[i1].x[0] ][ (pl[i1].y[0]-1) ]].m!=1)
				  || (pl[i1].y[0]<=0) || (xy_pl_exist(pl[i1].x[0],(pl[i1].y[0]-1),0)<250) ) { c_move=0; }
				new_x=pl[i1].x[0];
				new_y=pl[i1].y[0]-1;
				break;

	   // Down
	   case 2 : if ( !(mapf[ map.m[ pl[i1].x[0] ][ (pl[i1].y[0]+1) ]].m!=1)
				  || (pl[i1].y[0]>=(n_map_ysize-1)) || (xy_pl_exist(pl[i1].x[0],(pl[i1].y[0]+1),0)<250) ) { c_move=0; }
				new_x=pl[i1].x[0];
				new_y=pl[i1].y[0]+1;
				break;

	   // Left
	   case 3 : if ( !(mapf[ map.m[ (pl[i1].x[0]-1) ][ pl[i1].y[0] ]].m!=1)
				  || (pl[i1].x[0]<=0) || (xy_pl_exist((pl[i1].x[0]-1),pl[i1].y[0],0)<250) ) { c_move=0; }
				new_x=pl[i1].x[0]-1;
				new_y=pl[i1].y[0];
				break;

	   // Right
	   case 4 : if ( !(mapf[ map.m[ (pl[i1].x[0]+1) ][ pl[i1].y[0] ]].m!=1)
				  || (pl[i1].x[0]>=(n_map_xsize-1)) || (xy_pl_exist((pl[i1].x[0]+1),pl[i1].y[0],0)<250) ) { c_move=0; }
				new_x=pl[i1].x[0]+1;
				new_y=pl[i1].y[0];
				break;

	  // Unknown direction ... it will be better if we will not move ;-)
	  default : c_move=0; break;
	}

	// Add or remove length
	if ( (pl[i1].alen<int(pl[i1].blen)) && (c_move==1) ) pl[i1].alen++;
	if (pl[i1].alen>int(pl[i1].blen)) pl[i1].alen--;

	if (pl[i1].alen<1) { pl[i1].alen=1; pl[i1].blen=1.0; }
	if (pl[i1].alen>(MAX_PL_LENGTH-1)) { pl[i1].alen=(MAX_PL_LENGTH-1); pl[i1].blen=(float(MAX_PL_LENGTH)-1.0); }

	// Change other worm prop.
	i2=xy_pl_exist(new_x,new_y,0); // Player number
	i3=xy_pl_exist(new_x,new_y,1); // Player filed num
	if ( (i2<250) && (i2!=i1) )
	{
	  //printf(" - %i\n",i2);
	  pl[i2].alen=i3;
	  pl[i2].blen=i3;
	}

	// If move is possible, worm will move to the new position
	if (c_move==1)
	{
	  // Finally, we move the worm
	  for (i2=pl[i1].alen; i2>0; i2--)
	  {
		pl[i1].x[i2]=pl[i1].x[(i2-1)];
		pl[i1].y[i2]=pl[i1].y[(i2-1)];
	  }
	  pl[i1].x[0]=new_x;
	  pl[i1].y[0]=new_y;
	}

	// Changing length with properties of map field
	switch (map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ])
	{
	  //case 0 : pl[i1].blen=pl[i1].blen-0.01; break;
	  case 2 : pl[i1].blen=pl[i1].blen+0.1; break;
	  case 3 : pl[i1].blen++; break;
	}
	if (map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ]!=0)
	{
	  map.m[ (pl[i1].x[0]) ][ pl[i1].y[0] ]=0;
	}
  }

  // Move views
  for (i1=0; i1<n_views; i1++)
  {
	if (views[i1].mv<250)
	{
	  // Move view with player
	  views[i1].xm=pl[ views[i1].mv ].x[0]-(views[i1].xs / 2);
	  views[i1].ym=pl[ views[i1].mv ].y[0]-(views[i1].ys / 2);

	  // If we are on the end, don't move view
	  /*
	  if (views[i1].xm<0) views[i1].xm=0;
	  if (views[i1].ym<0) views[i1].ym=0;
	  if ((views[i1].xm+views[i1].xs)>(n_map_xsize-1)) views[i1].xm=n_map_xsize-views[i1].xs;
	  if ((views[i1].ym+views[i1].ys)>(n_map_ysize-1)) views[i1].ym=n_map_ysize-views[i1].ys;
	  */
	}
  }
}

void show_version_info()
{
  tcolor(7,0);
  clrscr();

  tcolor(15,0);
  cprintf("Basic control info:\r\n");
  tcolor(11,0); cprintf("Player1 - arror keys + Z(decrease length) + X(stop worm) + C(increase length)\r\n");
  tcolor(10,0); cprintf("Player2 - W(up) + S(down) + A(left) + D(right)\r\n");
  tcolor( 9,0); cprintf("Player3 - I(up) + K(down) + J(left) + L(right)\r\n\n");

  tcolor(15,0);
  cprintf("Other control info:\r\n");
  tcolor(7,0);
  cprintf("DELETE - switch to one player mode (default)\r\n");
  cprintf("INSERT - switch to two players mode\r\n");
  cprintf("HOME   - switch to three players mode\r\n\n");

  //tcolor(15,0);
  //cprintf("OKAY, now press any key to begin game ;-) ...");
  //getch();

  tcolor(7,0);
}

void main()
{
  textmode (C4350);
  randomize();

  show_version_info();

  //init_map();
  load_map(MAP_FILE_NAME);
  init_pl();
  init_views();

  redraw_basic_screen();

  while (end_p==0)
  {
	get_keyb();
	do_game();
	redraw_screen();

	// Game timer
	timer1++;
	gotoxy (1,1); printf("%i", timer1);
  }

  tcolor(7,0);
  gotoxy(1,50);
}
